/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package bo.gob.adsib.validador.test.itext2;

import com.itextpdf.kernel.geom.Rectangle;
import com.itextpdf.kernel.pdf.PdfReader;
import com.itextpdf.kernel.pdf.StampingProperties;
import com.itextpdf.signatures.BouncyCastleDigest;
import com.itextpdf.signatures.IExternalDigest;
import com.itextpdf.signatures.IExternalSignature;
import com.itextpdf.signatures.PdfSignatureAppearance;
import com.itextpdf.signatures.PdfSigner;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.security.GeneralSecurityException;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author alberto
 */
public class Main {
    public static void main(String[] args) {
        try {
            PdfReader reader = new PdfReader(new FileInputStream("prueba.pdf"));
            PdfSigner signer = new PdfSigner(reader, new FileOutputStream("prueba.signed.pdf"), new StampingProperties());
            
            // Create the signature appearance
            Rectangle rect = new Rectangle(0, 0, 0, 0);
            PdfSignatureAppearance appearance = signer.getSignatureAppearance();
            appearance.setPageRect(rect);
            signer.setFieldName("sig");
            
            IExternalDigest digest = new BouncyCastleDigest();
            IExternalSignature signature = new ServerSignature("12345678", "355409121073");
            
            // Sign the document using the detached mode, CMS or CAdES equivalent.
            signer.signDetached(digest, signature, ((ServerSignature)signature).getChain(), null, null, null, 0, PdfSigner.CryptoStandard.CADES);
        } catch (FileNotFoundException ex) {
            Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException | GeneralSecurityException ex) {
            Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
}
